SD_HWDB_NEW(3)

NAME
sd_hwdb_new, sd_hwdb_ref, sd_hwdb_unref - Create a new hwdb object and create or destroy references to it

SYNOPSIS

#include <systemd/sd-hwdb.h>

int sd_hwdb_new(sd_hwdb **hwdb);

sd_hwdb* sd_hwdb_ref(sd_hwdb *hwdb);

sd_hwdb* sd_hwdb_unref(sd_hwdb *hwdb);

DESCRIPTION

sd_hwdb_new() creates a new hwdb object to access the binary hwdb database. Upon initialization, the file containing the binary representation of the hardware database is located and opened. The new object is returned in hwdb.

The hwdb object is reference counted. sd_hwdb_ref() and sd_hwdb_unref() may be used to get a new reference or destroy an existing reference to an object. The caller must dispose of the reference acquired with sd_hwdb_new() by calling sd_hwdb_unref() when done with the object.

Use sd_hwdb_seek(3), sd_hwdb_get(3), and sd_hwdb_enumerate(3) to access entries.

RETURN VALUE

On success, sd_hwdb_new() returns a non-negative integer. On failure, it returns a negative errno-style error code.

sd_hwdb_ref() always returns the argument.

sd_hwdb_unref() always returns NULL.

  Errors

Returned errors may indicate the following problems:

-ENOENT
    The binary hardware database file could not be located. See systemd-hwdb(8) for more information.

-EINVAL
    The located binary hardware database file is in an incompatible format.

-ENOMEM
    Memory allocation failed.

NOTES

These APIs are implemented as a shared library, which can be compiled and linked to with the libsystemd pkg-config(1) file.

SEE ALSO

systemd(1), systemd-udevd.service(8), sd-hwdb(3), systemd-hwdb(3)